package com.base.locationsharewhite.location

import android.os.Build
import com.base.locationsharewhite.BuildConfig
import com.base.locationsharewhite.helper.AESHelper
import com.base.locationsharewhite.helper.ConfigHelper
import com.base.locationsharewhite.helper.ReportUtils
import com.base.locationsharewhite.location.LocationLoginUtils.extractData
import com.base.locationsharewhite.utils.AppPreferences
import com.base.locationsharewhite.utils.LogEx
import org.json.JSONObject

/**
 * 通过邀请码建立分享关系
 */
object LocationShareUtils {

    private val TAG = "LocationShareUtils"

    const val SHARE_STATE_FAILED = 0
    const val SHARE_STATE_SUCCESS = 1
    const val SHARE_STATE_SHARED = 2
    const val SHARE_STATE_MYSELF = 3

    /**
     * 分享位置接口
     */
    private val url by lazy {
        val pkg = ConfigHelper.packageName
        val url = StringBuilder(
            "${ConfigHelper.apiUrl}/dingwei/${pkg.filter { it.isLowerCase() }.substring(4, 9)}m"
        )
        url.append("?pkg=$pkg")
        url.toString()
    }

    fun shareMyLocationByInvitationCode(
        invitationCode: String,
        callBack: (state: Int) -> Unit
    ) {
        Thread {
            val pkg = ConfigHelper.packageName

            val data = JSONObject()
            data.put("invitationCode", invitationCode)
            LogEx.logDebug(TAG, "invitationCode=${invitationCode}")
            val bp = JSONObject()
//            .put("${pkg}_1", "")
                .put("${pkg}_5", Build.VERSION.SDK_INT)
                .put("${pkg}_8", BuildConfig.VERSION_NAME)
                .put("${pkg}_9", AppPreferences.getInstance().getString("uuid", ""))
                .put("${pkg}_10", AppPreferences.getInstance().getString("uuid", ""))//gid
                .put("${pkg}_13", "android")
                .put("${pkg}_14", BuildConfig.VERSION_CODE)
                .put("${pkg}_15", "google")
                .put("${pkg}_24", BuildConfig.BUILD_TYPE)
            LogEx.logDebug(TAG, "uuid=${AppPreferences.getInstance().getString("uuid", "")}")
            val body = JSONObject()
                .put("data", data)
                .put("bp", bp)
                .toString()

            val paramJson = AESHelper.encrypt(body)
            runCatching {
                val result = ReportUtils.doPost(url, HashMap(), paramJson)
                val responseData = extractData(result)
                if (responseData != null) {
                    val state = AESHelper.decrypt(responseData).toInt()
                    callBack.invoke(state)
                } else {
                    callBack.invoke(0)
                }
            }
        }.start()
    }
}